import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.net.InetAddress;
import java.net.Socket;
import java.util.Enumeration;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Servlet implementation class ClientServlet
 */
public class ClientServlet extends HttpServlet {
	private static final long serialVersionUID = 1L;

	/**
	 * @see HttpServlet#HttpServlet()
	 */
	public ClientServlet() {
		super();
		// TODO Auto-generated constructor stub
	}

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse
	 *      response)
	 */
	protected void doGet(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		FileReader fileReader = new FileReader(
				"/home/anki4/Desktop/HomeWork2.html");
		BufferedReader bufferReader = new BufferedReader(fileReader);
		PrintWriter printWriter = response.getWriter();
		String html = "";
		String line;
		while ((line = bufferReader.readLine()) != null) {
			html += line;
		}
		fileReader.close();
		printWriter.print(html);
		printWriter.close();
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse
	 *      response)
	 */
	protected void doPost(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {

		InetAddress host = InetAddress.getLocalHost();
		Socket socket = new Socket(host.getHostName(), 1574);
		PrintWriter printWriter = response.getWriter();

		Enumeration paramNames = request.getParameterNames();

		String[] paramValues = new String[3];
		int index = 0;

		while (paramNames.hasMoreElements()) {
			String paramName = (String) paramNames.nextElement();
			paramValues[index] = request.getParameterValues(paramName)[0];
			index++;
		}
		if (paramValues[0].equals("") || paramValues[2].equals("")) {
			error(printWriter, "ONE OF FIELD IS EMPTY!!!");
		}
		if (paramValues[1].equals("Download")) {
			downloadFile(paramValues[2], paramValues[0], socket, printWriter);
			ok(printWriter);
		}

		if (paramValues[1].equals("Upload")) {
				uploadFile(paramValues[2], paramValues[0], socket, printWriter);
				ok(printWriter);
		}
		printWriter.close();
		socket.close();
	}

	private void uploadFile(String fileName, String newFileName, Socket socket,
			PrintWriter printWriter){
		DataOutputStream out = null;
		DataInputStream in = null;
		DataInputStream input = null;
		try {
			out = new DataOutputStream(socket.getOutputStream());
			in = new DataInputStream(socket.getInputStream());
			sendMessage("-s", out);
			sendMessage(newFileName + "\0", out);
			byte msg = in.readByte();
			if (((Byte) msg).equals((byte) 'f')) {
				error(printWriter, "Server can't create file!");
			}
			if (((Byte) msg).equals((byte) 't')) {
				File file = new File(fileName);
				FileInputStream fileInputStream = new FileInputStream(file);
				sendMessage("t", out);
				byte[] arr = new byte[4096];
				int br = -1;
				while ((br=fileInputStream.read(arr))!=-1) {
					out.write(arr, 0, br);
					out.flush();
				}
				fileInputStream.close();
				out.close();
				in.close();
			}
		} catch (Exception e) {
			sendMessage("f", out);
			error(printWriter, e.toString());
		}
	}

	private void downloadFile(String fileName, String newFileName, Socket socket, PrintWriter printWriter) {
		DataOutputStream out = null;
		DataInputStream in = null;
		DataInputStream input = null;
		try {
			out = new DataOutputStream(socket.getOutputStream());
			in = new DataInputStream(socket.getInputStream());
			sendMessage("-r", out);
			sendMessage(fileName + "\0", out);
			byte msg = in.readByte();
			if (((Byte) msg).equals((byte) 'f')) {
				error(printWriter, "Server can't open file!");
			}
			if (((Byte) msg).equals((byte) 't')) {
				File file = new File(newFileName);
				FileOutputStream fileOutputStream = new FileOutputStream(file);
				sendMessage("t", out);
				byte[] arr = new byte[4096];
				int br = -1;
				while ((br=in.read(arr))!=-1) {
					fileOutputStream.write(arr,0,br);
					fileOutputStream.flush();
				}
				fileOutputStream.close();
				out.close();
				in.close();
			}
		} catch (Exception e) {
			sendMessage("f", out);
			error(printWriter, e.toString());
		}
	
	}

	void sendMessage(String msg, DataOutputStream out) {
		try {
			out.write(msg.getBytes(), 0, msg.getBytes().length);
			out.flush();
		} catch (IOException ioException) {
			ioException.printStackTrace();
		}
	}

	private void error(PrintWriter printWriter, String massege) {
		printWriter.println("<html><head>");
		printWriter.println("<title>ERROR!</title></head>");
		printWriter.println("<body bgcolor=\"black\" topmargin=\"150\"><center><font color=\"red\" ><b><i><big><u>");
		printWriter.println(massege);
		printWriter.println("<br><br><br><a href=\"http://localhost:8080/homework2/ClientServlet\">back</a>");
		printWriter.println("</u></big></i></b></font></center></body>");
		printWriter.println("</html>");
		printWriter.close();

	}
	private void ok(PrintWriter printWriter) {
		printWriter.println("<html><head>");
		printWriter.println("<title>OK</title></head>");
		printWriter.println("<body bgcolor=\"black\" topmargin=\"150\"><center><font color=\"green\" ><b><i><big><u>");
		printWriter.println("EVERYTING IS OK!<br><br><br>CREAT NEW FILE<br><br><br>");
		printWriter.println("<a href=\"http://localhost:8080/homework2/ClientServlet\">back</a>");
		printWriter.println("</u></big></i></b></font></center></body>");
		printWriter.println("</html>");
		printWriter.close();

	}
}
